#!/usr/bin/python3
if __name__ == '__main__':
  import sys
  import os
  sys.path.insert(0, os.path.abspath('config'))
  import configure
  configure_options = [
    '--CXX_LINKER_FLAGS=-Wl,--no-as-needed',
    '--PETSC_ARCH=powerpc64le-linux-gnu-complex-debug',
    '--build=powerpc64le-linux-gnu',
    '--includedir=${prefix}/include',
    '--infodir=${prefix}/share/info',
    '--libdir=${prefix}/lib/powerpc64le-linux-gnu',
    '--localstatedir=/var',
    '--mandir=${prefix}/share/man',
    '--prefix=/usr/lib/petscdir/petsc3.15/powerpc64le-linux-gnu-complex-debug',
    '--runstatedir=/run',
    '--shared-library-extension=_complex',
    '--sysconfdir=/etc',
    '--with-blas-lib=-lblas',
    '--with-cc=mpicc',
    '--with-cxx-dialect=C++11',
    '--with-cxx=mpicxx',
    '--with-debugging=1',
    '--with-dependency-tracking=0',
    '--with-fc=mpif90',
    '--with-fftw-include=[]',
    '--with-fftw-lib=-lfftw3 -lfftw3_mpi',
    '--with-fftw=1',
    '--with-hdf5-include=/usr/include/hdf5/openmpi',
    '--with-hdf5-lib=-L/usr/lib/powerpc64le-linux-gnu/hdf5/openmpi -L/usr/lib/powerpc64le-linux-gnu/openmpi/lib -lhdf5 -lmpi',
    '--with-lapack-lib=-llapack',
    '--with-maintainer-mode=0',
    '--with-mumps-include=[]',
    '--with-mumps-lib=-ldmumps -lzmumps -lsmumps -lcmumps -lmumps_common -lpord',
    '--with-mumps=1',
    '--with-opencl=1',
    '--with-option-checking=0',
    '--with-pic=1',
    '--with-ptscotch-include=/usr/include/scotch',
    '--with-ptscotch-lib=-lptesmumps -lptscotch -lptscotcherr',
    '--with-ptscotch=1',
    '--with-scalapack-lib=-lscalapack-openmpi',
    '--with-scalapack=1',
    '--with-scalar-type=complex',
    '--with-shared-libraries',
    '--with-silent-rules=0',
    '--with-suitesparse-include=/usr/include/suitesparse',
    '--with-suitesparse-lib=-lumfpack -lamd -lcholmod -lklu',
    '--with-suitesparse=1',
    '--with-superlu-include=/usr/include/superlu',
    '--with-superlu-lib=-lsuperlu',
    '--with-superlu=1',
    '--with-superlu_dist-include=/usr/include/superlu-dist',
    '--with-superlu_dist-lib=-lsuperlu_dist',
    '--with-superlu_dist=1',
    '--with-yaml=1',
    '--with-zoltan-include=/usr/include/trilinos',
    '--with-zoltan-lib=-ltrilinos_zoltan',
    '--with-zoltan=1',
    'CFLAGS=-g -O3 -ffile-prefix-map=/build/petsc-oaBsSS/petsc-3.15.5+dfsg1=. -flto=auto -ffat-lto-objects -fstack-protector-strong -Wformat -Werror=format-security -fPIC',
    'CPPFLAGS=-Wdate-time -D_FORTIFY_SOURCE=2',
    'CXXFLAGS=-g -O3 -ffile-prefix-map=/build/petsc-oaBsSS/petsc-3.15.5+dfsg1=. -flto=auto -ffat-lto-objects -fstack-protector-strong -Wformat -Werror=format-security -fPIC',
    'FCFLAGS=-g -O3 -ffile-prefix-map=/build/petsc-oaBsSS/petsc-3.15.5+dfsg1=. -flto=auto -ffat-lto-objects -fstack-protector-strong -fPIC -ffree-line-length-0',
    'FFLAGS=-g -O3 -ffile-prefix-map=/build/petsc-oaBsSS/petsc-3.15.5+dfsg1=. -flto=auto -ffat-lto-objects -fstack-protector-strong -fPIC -ffree-line-length-0',
    'LDFLAGS=-Wl,-Bsymbolic-functions -flto=auto -Wl,-z,relro -fPIC',
    'MAKEFLAGS=w',
  ]
  configure.petsc_configure(configure_options)
